package sun.util.cldr;

import java.util.Collections;
import java.util.StringTokenizer;
import java.util.HashSet;
import java.util.ResourceBundle;
import java.util.Iterator;
import java.util.Set;
import java.util.Locale;
import java.text.spi.CollatorProvider;
import java.text.spi.BreakIteratorProvider;
import sun.util.locale.provider.LocaleProviderAdapter;
import java.security.PrivilegedAction;
import java.security.AccessController;
import sun.security.action.GetPropertyAction;
import java.io.File;
import sun.util.locale.provider.JRELocaleProviderAdapter;

public class CLDRLocaleProviderAdapter extends JRELocaleProviderAdapter
{
    private static final String LOCALE_DATA_JAR_NAME = "cldrdata.jar";
    
    public CLDRLocaleProviderAdapter() {
        String separator = File.separator;
        if (!(boolean)AccessController.doPrivileged(new PrivilegedAction<Boolean>() {
            
            @Override
            public Boolean run() {
                return Boolean.valueOf(f.exists());
            }
        })) {
            throw new UnsupportedOperationException();
        }
        return;
    }
    
    @Override
    public LocaleProviderAdapter.Type getAdapterType() {
        return LocaleProviderAdapter.Type.CLDR;
    }
    
    @Override
    public BreakIteratorProvider getBreakIteratorProvider() {
        return null;
    }
    
    @Override
    public CollatorProvider getCollatorProvider() {
        return null;
    }
    
    @Override
    public Locale[] getAvailableLocales() {
        Set<String> languageTagSet = this.createLanguageTagSet("All");
        Locale[] array = new Locale[languageTagSet.size()];
        int n = 0;
        Iterator<Object> iterator = languageTagSet.iterator();
        while (iterator.hasNext()) {
            array[n++] = Locale.forLanguageTag((String)iterator.next());
        }
        return array;
    }
    
    @Override
    protected Set<String> createLanguageTagSet(String key) {
        String string = ResourceBundle.getBundle("sun.util.cldr.CLDRLocaleDataMetaInfo", Locale.ROOT).getString(key);
        if (string == null) {
            return Collections.emptySet();
        }
        HashSet<String> set = new HashSet();
        StringTokenizer stringTokenizer = new StringTokenizer(string);
        while (stringTokenizer.hasMoreTokens()) {
            set.add(stringTokenizer.nextToken());
        }
        return set;
    }
}
